#ifndef ARCHPROFILEEDITOR_H
#define ARCHPROFILEEDITOR_H
//
#include "ui_networkprofileeditor.h"
#include <QDialog>
#include <QProcess>
#include <QPushButton>
#include <QLineEdit>
#include <QComboBox>
#include <QMap>

class QProcess;
class QPushButton;
class QLineEdit;
class QComboBox;
//
class ArchProfileEditor:public QDialog, public Ui::NetworkProfileEditorDialog
{
	Q_OBJECT

	public:
		ArchProfileEditor(QWidget * parent = 0, Qt::WFlags f = 0, QString profileFile = "");

	private:
		QString profileName;
		QString hostName;
		QString interfaceName;
		QString descriptionName;
		
		void initNewProfile();
		void initEditedProfile(QString);
		QStringList getAvailableInterfaces();
		QString getCurrentHostName();
		QMap<QString, QString> getProfileKeys(QString, QString);

	private slots:
		void profileGenerator();
		void useDhcpStateChanged(int);
		void pbChooseEssidClicked();
		void updateBroadcastAdress(const QString&);
		void cbInterfaceNameStateChanged(const QString&);
		void cbWirelessModeStateChanged(const QString&);
};
#endif
