/***************************************************************************
 *   Copyright (C) 2007 by pizza.tony   *
 *   pizza.tony@free.fr   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <QtGui>
#include <QSystemTrayIcon>

archsystray::archsystray()
{
	initSystray();
	//connect(myProcess, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(processEnded(int, QProcess::ExitStatus)));
	systray->show();
}

void archsystray::initSystray()
{
	systray = new QSystemTrayIcon(this);
	systray->setParent(this);
	systray->setIcon(QIcon(":/archlogo.png"));
	systray->setToolTip(QString("<b>Arch Assistant</b>"));

	QAction *actionSystrayQuit = new QAction( trUtf8("Quit"), this );
	actionSystrayQuit->setIcon( QIcon(":/exit.png")  );
	actionSystrayQuit->connect( actionSystrayQuit, SIGNAL( triggered() ), this, SLOT( close() ) );

	systrayMenu = new QMenu("Arch Assistant");
	//systrayMenu->setTitle("Arch Assistant");
	//systrayMenu->addMenu(configFilesMenu);
	//systrayMenu->addMenu(networkProfilesMenu);
	//systrayMenu->addMenu(networkMenu);
	//systrayMenu->addMenu(pacmanMenu);
	//systrayMenu->addAction(actionPacman);
	//systrayMenu->addAction(actionSystrayConfigure);
	//systrayMenu->addSeparator();
	//systrayMenu->addAction(actionSystrayShowHide);
	systrayMenu->addAction(actionSystrayQuit);


	systray->setContextMenu(systrayMenu);

}


archsystray::~archsystray()
{
}