#ifndef DIALOGIMPL_H
#define DIALOGIMPL_H
//
//#include<QtGui>
#include <QSystemTrayIcon>
#include <QProcess>
#include <QMap>

class QAction;
class QMenu;
class QTextEdit;
class QSystemTrayIcon;
class QProcess;
class QDir;
class QSignalMapper;
//
//class DialogImpl : public QDialog, public Ui::Dialog
class DialogImpl : public QSystemTrayIcon
{
Q_OBJECT

public:
	//DialogImpl( QWidget * parent = 0 , QString args = 0 );
	DialogImpl( QObject * parent = 0 );
	
//public slots:
//	void networkProfilesMenuUpdate();

private slots:
	void systemFileClicked(int);
	void systemInfoClicked(int);
	void networkProfileClicked(int);
	void networkProfileStopAllClicked();
	void networkProfileManage();
	void networkProfileAutomatic();
	void pacmanActionClicked(int);
	void customActionClicked(int);
	void pacmanProcessEnded(int, QProcess::ExitStatus);
	void networkProfileProcessOutput();
	void networkProfileProcessEnded(int, QProcess::ExitStatus);
	void networkProfilesMenuUpdate();
	void settingsEdit();
	void customActionsEdit();
	void systemInfosListEdit();
	void systemFilesListEdit();
	void showAbout();
	
	//void pacProcessEnded(int, QProcess::ExitStatus);
	//void pacProcessError(QProcess::ProcessError);
	//void pacProcessOutput();
	void pacProcessStart();
	
	
private:
	//QSystemTrayIcon *systray;
	QMenu *systrayMenu;
	QMenu *networkMenu;
	QMenu *networkProfilesMenu;
	QMenu *systemInfoMenu;
	QMenu *configFilesMenu;
	QMenu *pacmanMenu;
	QMenu *customActionMenu;
	
	//QProcess *pacProcess;
	//QProcess *customActionProcess;
	QProcess *pacmanProcess;
	QProcess *networkProfileProcess;

	bool pacmanProcessRunning;
	bool networkProcessRunning;
	bool networkProfileConnected;
	//bool askingConnectionFromAutoconnect;
	
	QString pacmanBin;
	QString shellBin;
	QString settingsPath;
	QString settingsDir;
	QString wlanDevice;
	QString autoconnectOnStartup;
	QString networkProfileSelected;
	QString getEssidForProfile(QString);
	QString getWifiInterface();
	QString fileSystemActionsList;
	QString filePacmanActionsList;
	QString fileSystemFilesList;
	QString fileCustomActionsList;
	
	QStringList profileName;
	//QStringList systemFilesName;
	QMap<int, QStringList> customActionsName;
	QMap<int, QStringList> systemFilesName;
	//QStringList systemInfoName[50];
	QMap<int, QStringList> systemInfoName;
	QStringList pacmanAction[9];
	
	QMap<int, QStringList> readActionsList(QString);
	QStringList getInterfacesList();
	
	//QTextEdit *pacTe;
	int getRunningInterfacesCount();
	bool networkProfileStopAll();
	void initSystray();
	void settingsRead();
	void settingsGenerate();
	//void settingsWrite();
	
	
};
#endif




