//
// C++ Implementation: systeminfosassistant
//
// Description: 
//
//
// Author: pizza.tony <pizza.tony@free.fr>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "systeminfosassistant.h"
#include <QtGui>
#include <QProcess>
#include <QFile>
#include <QMap>
#include <QByteArray>
//#include <QIODevice>

//#include <iostream>
//using namespace std;

SystemInfosAssistant::SystemInfosAssistant(int actionIndex) : QDialog()
{

	//QMap<int, QStringList> systemInfoName = readActionsList(":/in.txt");
	//QString actionsFileName = "in.txt";
	systemInfoName = readActionsList("systemactions.txt");

// 	if (systemInfoName.size() < 1)
// 	{
// 		QMessageBox::warning(this, tr("File Error"),
// 									tr("Cannot read file '%1'.").arg(actionsFileName)
// 							);
// 		close();
// 	}

	/*
	for (int i = 0; i < systemInfoName.size(); ++i)
		cout << systemInfoName[i].at(1).toLocal8Bit().constData() << systemInfoName[i].at(2).toLocal8Bit().constData() << endl;
	
	//return;

	systemInfoName[0] << "-T" << "ifconfig" << "--noclose" << "-e" << "ifconfig";
	systemInfoName[1] << "-T" << "iwconfig" << "--noclose" << "-e" << "iwconfig";
	systemInfoName[2] << "-T" << "iwlist" << "--noclose" << "-e" << "iwlist scan";
	systemInfoName[3] << "-T" << "route" << "--noclose" << "-e" << "route";
	systemInfoName[4] << "-T" << "dmesg" << "--noclose" << "-e" << "dmesg";
	systemInfoName[5] << "-T" << "locale -a" << "--noclose" << "-e" << "locale -a";
	systemInfoName[6] << "-T" << "Disk Free" << "--noclose" << "-e" << "df -h";
	systemInfoName[7] << "-T" << "glxgears" << "--noclose" << "-e" << "glxgears";
	systemInfoName[8] << "-T" << "lsmod" << "--noclose" << "-e" << "lsmod";
	systemInfoName[9] << "-T" << "lspci" << "--noclose" << "-e" << "lspci";
	systemInfoName[10] << "-T" << "lspnp" << "--noclose" << "-e" << "lspnp";
	systemInfoName[11] << "-T" << "pstree" << "--noclose" << "-e" << "pstree";
	systemInfoName[12] << "-R" << "locate [request]" << "--noclose" << "-e" << "locate";
	systemInfoName[13] << "-R" << "which [request]" << "--noclose" << "-e" << "which";
	systemInfoName[14] << "-R" << "wget [request]" << "--noclose" << "-e" << "wget";
	systemInfoName[15] << "-R" << "aria2c [request]" << "--noclose" << "-e" << "aria2c";
	systemInfoName[16] << "-T" << "yaourt [request]" << "--noclose" << "-e" << "yaourt --nocolor -Ss xmoto";
	*/
	
	textEdit = new QTextEdit();
	cbInfosActions = new QComboBox();
	pbStart = new QPushButton(trUtf8("Start"));
	pbClose = new QPushButton(trUtf8("&Close"));
	leExtraArgs = new QLineEdit();
	//QLabel *label = new QLabel(systemInfoName[systemInfoIndex].at(1), textEditDlg);
	//QPushButton *pbSave = new QPushButton("&Save", textEditDlg);

	// Fill combo box
// 	for (int i = 0; i < 17; ++i)
// 	{
// 		cbInfosActions->addItem(systemInfoName[i].at(1), systemInfoName[i].at(4));
// 	}

	if (systemInfoName.size() > 0)
	{
		for (int i = 0; i < systemInfoName.size(); ++i)
		{
			cbInfosActions->addItem(systemInfoName[i].at(1), systemInfoName[i].at(2));
		}

		cbInfosActions->setCurrentIndex(actionIndex);
		//cbActionsChanged();
	}
	else
		pbStart->setDisabled(true);
	

	QHBoxLayout *layoutH1 = new QHBoxLayout;
	layoutH1->addWidget( cbInfosActions );
	layoutH1->addStretch();
	layoutH1->addWidget( leExtraArgs );
	layoutH1->addStretch();
	layoutH1->addWidget( pbStart );
	
	QHBoxLayout *layoutH = new QHBoxLayout;
	layoutH->addStretch();
	//layoutH->addWidget( pbSave );
	layoutH->addWidget( pbClose );
	
	QVBoxLayout *layout = new QVBoxLayout;
	//layout->addWidget( label );
	//layout->addWidget( cbInfosActions );
	layout->addLayout( layoutH1 );
	layout->addWidget( textEdit );
	layout->addLayout( layoutH );
		
	//GOODtextEdit->setPlainText(systemInfoProcess->readAll());


	//textEdit->setPlainText(systemInfoProcess->readAllStandardOutput());
	//textEdit->setPlainText(systemInfoProcess->readAllStandardError());
	textEdit->setReadOnly(true);
	
	connect( pbStart, SIGNAL( clicked() ), this, SLOT( processStart() ) );
	connect( pbClose, SIGNAL( clicked() ), this, SLOT( close() ) );
	connect( cbInfosActions, SIGNAL( currentIndexChanged (int) ), this, SLOT( cbActionsChanged() ) );

	
	setLayout(layout);
	//setModal(true);
	setSizeGripEnabled(true);
	setWindowTitle ( tr("Arch Assistant - System Info") );
	setWindowIcon(QIcon(":/archlogo.png"));
	setMinimumSize(600, 400);
	//show();

	if (systemInfoName.size() > 0)
	{
		if(systemInfoName[cbInfosActions->currentIndex()].at(0) != "-R")
			processStart();
		else
			leExtraArgs->setFocus();
	}
}

void SystemInfosAssistant::processStart()
{
	// Execute requested process
	systemInfoProcess = new QProcess();
	systemInfoProcess->setProcessChannelMode(QProcess::MergedChannels);

	/*
	if(systemInfoName[cbInfosActions->currentIndex()].at(0) == "-R")
		systemInfoProcess->start( systemInfoName[cbInfosActions->currentIndex()].at(2) + " " + leExtraArgs->text() );//systemInfoProcess->start( systemInfoName[cbInfosActions->currentIndex()].at(4) + " " + leExtraArgs->text() );
	else
		systemInfoProcess->start( systemInfoName[cbInfosActions->currentIndex()].at(2) );//systemInfoProcess->start( systemInfoName[cbInfosActions->currentIndex()].at(4) );
	*/

	if ( leExtraArgs->text().trimmed().size() > 0 )
		systemInfoProcess->start( systemInfoName[cbInfosActions->currentIndex()].at(2) + " " + leExtraArgs->text() );
	else
		systemInfoProcess->start( systemInfoName[cbInfosActions->currentIndex()].at(2) );

	pbStart->setDisabled(true);
	pbClose->setText(trUtf8("Abort"));

	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));

	if (!systemInfoProcess->waitForStarted())
	{
		//cout << "process could not start" << endl;
		QMessageBox::critical(this, tr("Process error"),
							  tr("process could not start.")
							 );
		processEnd();
		textEdit->clear();
		return;
	}
	if (!systemInfoProcess->waitForFinished())
	{
		//cout << "process failed to finish properly" << endl;
		QMessageBox::critical(this, tr("Process error"),
							 tr("process could not finish properly.")
							 );
		processEnd();
		textEdit->clear();
		return;
	}
	
	textEdit->setPlainText(systemInfoProcess->readAll());
	processEnd();
}

void SystemInfosAssistant::processEnd()
{
	pbStart->setDisabled(false);
	pbClose->setText(trUtf8("Close"));
	
	QApplication::setOverrideCursor(QCursor(Qt::ArrowCursor));
}

void SystemInfosAssistant::cbActionsChanged()
{
	leExtraArgs->clear();
	/*
	if ( systemInfoName[cbInfosActions->currentIndex()].at(0) == "-R" )
	{
		leExtraArgs->setDisabled(false);
		leExtraArgs->setFocus();
	}
	else
		leExtraArgs->setDisabled(true);
	*/
}

QMap<int, QStringList> SystemInfosAssistant::readActionsList(QString fileName)
{
	QMap<int, QStringList> map;
	QString fileNameFound = "";
	QString settingsPath = QString("%1/%2").arg(QDir::homePath()).arg(".archassistant");

	// guess source file location

	if ( !QFile::exists( QString("%1/%2").arg(settingsPath).arg(fileName) ) )
	{
		if ( !QFile::copy( QString(":/%1").arg(fileName), QString("%1/%2").arg(settingsPath).arg(fileName) ) )
		{
			QMessageBox::warning(this, tr("File Error"),
								 tr("Cannot read file '%1'.").arg(fileName));
			return map;
		}
	}
	
	if ( QFile::exists( QString("%1/%2").arg(settingsPath).arg(fileName) ) )
		fileNameFound = QString("%1/%2").arg(settingsPath).arg(fileName);
	else if (QFile::exists( QString(":/%1").arg(fileName) ) )
		fileNameFound = QString(":/%1").arg(fileName);
	else
	{
		QMessageBox::warning(this, tr("File Error"),
		tr("Cannot read file '%1'.").arg(fileName));
		
		return map;
	}
	
	QFile file(fileNameFound);
	if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
		return map;

	int i = 0;

	while (!file.atEnd()) {
		QByteArray line = file.readLine();
		map[i] = QString(line).split(";");
		++i;
	}

	return map;
}

// SystemInfosAssistant::~SystemInfosAssistant()
// {
// }


